import 'package:flutter/material.dart';
import 'package:shopmate/controls/controls.dart';
import 'package:shopmate/features/catalog/models/models.dart';
import 'package:shopmate/features/catalog/widgets/widgets.dart';
import 'package:show/show.dart';

void showCase(Show controls) {
  controls
    ..setTitle('Controls')
    ..setLayout(Layout.gridLayout)
    ..add('SizesDropdown', {
      () => SizesDropDown(
            value: 'S',
            onChanged: action('Selected Size'),
            sizes: [
              ProductAttribute(value: 'S'),
              ProductAttribute(value: 'M'),
              ProductAttribute(value: 'L'),
            ],
          ),
    })
    ..add('SizeChooser', {
      () => SizeChooser(
            onSelect: action('Selected Size'),
            sizes: [
              ProductAttribute(value: 'S'),
              ProductAttribute(value: 'M'),
              ProductAttribute(value: 'L'),
            ],
          ),
    })
    ..add('NumericStepper', {
      () => NumericStepper(
            onDecrease: action('Decrease'),
            onIncrease: action('Increase'),
            onChanged: action('Changed'),
          ),
    })
    ..decorate((Widget child) => Padding(
          padding: const EdgeInsets.all(18.0),
          child: Card(child: child),
        ))
    ..add('Ratings', {
      () => Ratings(rating: 1),
      () => Ratings(rating: 4),
      () => Ratings(rating: 5),
    })
    ..decorate()
    ..add('Color', {
      () => ColorChooser(
            colors: [
              ProductColor(id: 1, value: 'Red', color: Colors.red),
              ProductColor(id: 2, value: 'Green', color: Colors.green),
              ProductColor(id: 3, value: 'Blue', color: Colors.blue),
            ],
          ),
    })
    ..add(
      'RoundedButton',
      {
        () => RoundedButton(text: 'Hi!'),
        () => RoundedButton(text: 'Hi!'),
        () => RoundedButton(
              text: 'Hi!',
              onPressed: action<VoidCallback>('Pressed'),
            )
      },
      layout: Layout.gridLayout,
    );
}
